var o_MaximumSupportedVersion = 1; // change also this value in follow up servlet code
var o_FollowUpPagePath = "workcaseGraphicalFollowUp.jsp";
var o_FollowUpDefinitionFilePath = "../WorkcaseGraphicalFollowUp/";
var o_DictionaryPathPrefix = "../jsp/properties/graphicalFollowUp";
var o_DictionaryExtension = ".xml";
var o_ImagesFolderPath = "../images/GraphicalFollowUp/";
var o_StepImagesFolderPath = "../images/GraphicalFollowUp/Step/";
var o_CustomStepImagesFolderPath = "../images/GraphicalFollowUp/CustomStep/";
var o_DeadlineImagesFolderPath = "../images/GraphicalFollowUp/Deadline/";
var o_AssignmentImagesFolderPath = "../images/GraphicalFollowUp/Assignment/";
var skin = "DEFAULT";
var colorsPerLaneStr = new Object();
var laneNames = new Array();

var o_SpacerName = "Spacer";
var o_ContentCanvasName = "ContentCanvas";
var o_BackgroundCanvasName = "BackgroundCanvas";
var o_ModelCanvasName = "ModelCanvas";
var o_TextCanvasName = "TextCanvas";
var o_TasksCanvasName = "TasksCanvas";
var o_MemoCanvasName = "MemoCanvas";
var o_AssignmentCanvasName = "AssignmentCanvas";
var o_DeadlineCanvasName = "DeadlineCanvas";
var o_ActionCanvasName = "ActionCanvas";
var o_NormalTextWorkingAreaName = 'NormalTextWorkingArea';
var o_TitleTextWorkingAreaName = 'TitleTextWorkingArea';
var o_SmallTextWorkingAreaName = 'SmallTextWorkingArea';
var o_NormalTextFontFamily = "Tahoma";
var o_NormalTextFontSize = "11px";
var o_NormalTextFontWeight = "normal";
var o_TitleTextFontFamily = "Tahoma";
var o_TitleTextFontSize = "11px";
var o_TitleTextFontWeight = "bold";
var o_SmallTextFontFamily = "Tahoma";
var o_SmallTextFontSize = "9px";
var o_SmallTextFontWeight = "normal";
var o_NormalColor = "#000000";
var o_NormalLinkColor = "#000000";
var o_ConditionalLinkColor = "#ff9900";
var o_SynchronizationLinkColor = "#ff9900";
var o_DeadlineLinkColor = "#0000ff";
var o_MemoBackgroudColor = "#ffff33";
var o_MemoLinkColor = "#696900";
var o_MemoStrokeColor = "#696900";
var o_NormalStroke = 1;
var o_SynchronizationLinkStroke = "--.";
var o_DeadlineStroke = 2;
var o_ArrowLength = 7;
var o_TasksImageWidth = 16;
var o_TasksImageHeight = 16;
var o_AssignmentImageWidth = 16;
var o_AssignmentImageHeight = 16;
var o_DeadlineImageWidth = 16;
var o_DeadlineImageHeight = 16;
var o_CanvasWidth = "740px";
var o_CanvasHeight = "480px";

function traceInfo(txt) {
  /*if (console) {
    console.log(txt);
  }   */
}

function getLaneColors(x, y)
{
  for (var i = 0; i < laneNames.length; i++)
  {
    var posX = colorsPerLaneStr [laneNames[i]]['posX'];
	var posY = colorsPerLaneStr [laneNames[i]]['posY'];
	var width = colorsPerLaneStr [laneNames[i]]['width'];
	var height = colorsPerLaneStr [laneNames[i]]['height'];
    if ((x >= posX) && (x <= (posX + width)) && (y >= posY) && ( y < (posY + height)))
	{
	  return colorsPerLaneStr [laneNames[i]];
	}
  }
  return '';
}

function initSkin(value)
{
  skin = value;
  o_ImagesFolderPath = "../images/GraphicalFollowUp/" + skin + "/";
  o_StepImagesFolderPath = o_ImagesFolderPath + "Step/";
  o_CustomStepImagesFolderPath = o_ImagesFolderPath + "CustomStep/";
  o_DeadlineImagesFolderPath = o_ImagesFolderPath + "Deadline/";
  o_AssignmentImagesFolderPath = o_ImagesFolderPath + "Assignment/";
}

function GraphicalContext(language,
                          dictionary,
                          spacer,
                          contentCanvas,
                          backgroundCanvas)
{
  this.getLanguage = function()
  {
    return language;
  };

  this.getDictionary = function()
  {
    return dictionary;
  };

  this.getSpacer = function()
  {
    return spacer;
  };

  this.getContentCanvas = function()
  {
    return contentCanvas;
  };

  this.getBackgroundCanvas = function()
  {
    return backgroundCanvas;
  };
}

function Point(x, y)
{
  this.getX = function()
  {
    return x;
  };

  this.getY = function()
  {
    return y;
  };
}

function Step(id, index, type, x, y, width, height, watchedStepIds)
{
  this.getId = function()
  {
    return id;
  };

  this.getIndex = function()
  {
    return index;
  };

  this.getType = function()
  {
    return type;
  };

  this.getX = function()
  {
    return x;
  };

  this.getY = function()
  {
    return y;
  };

  this.getWidth = function()
  {
    return width;
  };

  this.getHeight = function()
  {
    return height;
  };

  this.getWatchedStepIds = function()
  {
    return watchedStepIds;
  };
}

function Steps(stepsPerId, stepsPerIndex)
{
  this.getStepsPerId = function()
  {
    return stepsPerId;
  };

  this.getStepsPerIndex = function()
  {
    return stepsPerIndex;
  };
}

function Activity(logicalId)
{
  this.getLogicalId = function()
  {
    return logicalId;
  };
}

var disableBlinking = false;

function enableBlinking()
{
  disableBlinking = false;
}

function blinkCanvas(canvasDrawerName)
{
  if(disableBlinking)
  {
    return;
  }
  canvasDrawer = document.canvasDrawer[canvasDrawerName];
  canvasDrawer.setVisible(!canvasDrawer.isVisible());
}

function toggleCanvas(canvasDrawerName)
{
  disableBlinking = true;
  var li = document.getElementById(canvasDrawerName + 'Item');
  if(!canvasDrawer.isVisible())
  {
    appendAttribute(li, 'class', '');
  }
  else
  {
    appendAttribute(li, 'class', 'Selected');
  }
  setTimeout("enableBlinking();", 100);
}

function getAbsolutePosition(element)
{
  var left = null;
  var x = element.offsetLeft;
  while(element.offsetParent != null && !left)
  {
    var left = element.style.left;
    if(left)
    {
      if(left.match("px$"))
      {
        left = left.substr(0, left.length - 2);
      }
      x = left;
    }
    else
    {
      parentElement = element.offsetParent;
      x += parentElement.offsetLeft;
      element = parentElement;
    }
  }
  var top = null;
  var y = element.offsetTop;
  while(element.offsetParent != null && !top)
  {
    var top = element.style.top;
    if(top)
    {
      if(top.match("px$"))
      {
        top = top.substr(0, top.length - 2);
      }
      y = top;
    }
    else
    {
      parentElement = element.offsetParent;
      y += parentElement.offsetTop;
      element = parentElement;
    }
  }
  var position =
  {
    'x' : parseInt(x),
    'y' : parseInt(y)
  }
  return position;
}

var currentPanelHider = null;
var currentDisplayedPanel = null;

function hideCurrentPanel()
{
  if(currentDisplayedPanel != null)
  {
    currentDisplayedPanel.style.display = "none";
  }
}

function displayPanel(stepElement, panelId)
{
  hideCurrentPanel();
  var position = stepElement.getBBox();
  var panel = document.getElementById(panelId);
  panel.onmouseout = function()
  {
    currentPanelHider = setTimeout("hideCurrentPanel();", 2000);
  }
  panel.onmouseover = function()
  {
    clearTimeout(currentPanelHider);
  }
  var x = position.x + 20;
  var y = position.y + 20;
  panel.style.left = x + "px";
  panel.style.top = y + "px";
  if(!panel.style.display || panel.style.display == "none")
  {
    panel.style.display = "block";
  }
  else
  {
    panel.style.display = "none";
  }
  // $$$$ min width pb on IE gets the div/div/table width
  //var width = panel.childNodes[0].childNodes[0].offsetWidth;
  var width = 200;
  panel.style.width = width + "px";
  currentDisplayedPanel = panel;
}

function setPropertiesToWorkingArea(workingAreaName, fontFamily, fontSize, fontWeight)
{
  var workingArea = document.getElementById(workingAreaName);
  workingArea.style.fontFamily = fontFamily;
  workingArea.style.fontSize = fontSize;
  var fontWeightCssValue;
  this.PLAIN = 'font-weight:normal;';
  this.BOLD = 'font-weight:bold;';
  this.ITALIC = 'font-style:italic;';
  this.ITALIC_BOLD = this.ITALIC + this.BOLD;
  this.BOLD_ITALIC = this.ITALIC_BOLD;
  if(fontWeight == "bold")
  {
    workingArea.style.fontWeight = "bold";
  }
  else if(fontWeight == "italic")
  {
    workingArea.style.fontStyle = "italic";
  }
  else if(fontWeight == "bold italic")
  {
    workingArea.style.fontWeight = "bold";
    workingArea.style.fontStyle = "italic";
  }
  else if(fontWeight == "italic bold")
  {
    workingArea.style.fontWeight = "bold";
    workingArea.style.fontStyle = "italic";
  }
  else
  {
    workingArea.style.fontWeight = "normal";
  }
}

function appendElement(element, subElementName)
{
  var subElement = document.createElement(subElementName);
  element.appendChild(subElement);
  return subElement;
}

function appendAttribute(element, name, value)
{
  var attribute = document.createAttribute(name);
  attribute.nodeValue = value;
  element.setAttributeNode(attribute);
  return attribute;
}

function appendTextElement(element, subElementName, text)
{
  var subElement = document.createElement(subElementName);
  element.appendChild(subElement);
  var textNode = document.createTextNode(text);
  subElement.appendChild(textNode);
  return subElement;
}

function getNodeValue(node)
{
  var valueNode = node.childNodes[0];
  return valueNode.nodeValue;
}

function getTextSize(workingAreaName, text)
{
  var workingArea = document.getElementById(workingAreaName);
  workingArea.innerHTML = text;
  var width = workingArea.offsetWidth;
  var height = workingArea.offsetHeight;
  workingArea.innerHTML = '';
  var size =
  {
    'width' : width,
    'height' : height
  }
  return size;
}

function drawString(workingAreaName, horizontalAlignment, verticalAlignment, drawer, text, x, y)
{
  var size = getTextSize(workingAreaName, text);
  if(horizontalAlignment == "center")
  {
    x = x - size.width / 2;
  }
  else
  {
    if(horizontalAlignment == "right")
    {
      x = x - size.width;
    }
  }

  if(verticalAlignment == "middle")
  {
    y = y - size.height / 2;
  }
  else
  {
    if(verticalAlignment == "bottom")
    {
      y = y - size.height;
    }
  }
  var txtBox = drawer.paper.text(x, y, text).attr({'font-family':o_NormalTextFontFamily,'font-size':o_NormalTextFontSize,'font-weight':o_NormalTextFontWeight,'text-anchor':'start'});
  drawer.layer.push(txtBox);
  return txtBox;
}

function drawStringWrap(workingAreaName, horizontalAlignment, verticalAlignment, drawer, text, x, y, height, width)
{
  var size = getTextSize(workingAreaName, text);
  if(horizontalAlignment == "center")
  {
    x = x - size.width / 2;
  }
  else
  {
    if(horizontalAlignment == "right")
    {
      x = x - size.width;
    }
  }

  if(verticalAlignment == "middle")
  {
    y = y - size.height / 2;
  }
  else
  {
    if(verticalAlignment == "bottom")
    {
      y = y - size.height;
    }
  }
  var txtBox = drawer.paper.text(x, y, text).attr({'font-family':o_NormalTextFontFamily,'font-size':o_NormalTextFontSize,'font-weight':o_NormalTextFontWeight,'text-anchor':'start'}); 
  drawer.layer.push(txtBox);
  return txtBox;//, height, width);
}

function drawStringRotate(drawer, text, x, y, angle, width, height)
{
  var txtBox = drawer.paper.text(x+height/2, y+width/2, text).attr({'font-family':o_NormalTextFontFamily,'font-size':o_NormalTextFontSize,'font-weight':o_NormalTextFontWeight}).rotate(angle); 
  drawer.layer.push(txtBox);
  return txtBox;//, x, y, angle, width, height);
}

function drawStringInDiv(drawer, text, x, y, width, height)
{
  var txtBox = drawer.paper.text(x+width/2,y+height/2, text).attr({'font-family':o_NormalTextFontFamily,'font-size':o_NormalTextFontSize,'font-weight':o_NormalTextFontWeight});
  drawer.layer.push(txtBox);
  return txtBox;// width, height);
}

function drawNormalText(drawer, horizontalAlignment, verticalAlignment, text, x, y)
{
  return drawString(o_NormalTextWorkingAreaName, horizontalAlignment, verticalAlignment, drawer, text, x, y);
}

function drawNormalTextWrap(drawer, horizontalAlignment, verticalAlignment, text, x, y, height, width)
{
  return drawStringWrap(o_NormalTextWorkingAreaName, horizontalAlignment, verticalAlignment, drawer, text, x, y, height, width);
}

function drawTitleText(drawer, text, x, y)
{
  return drawString(o_TitleTextWorkingAreaName, 'left', 'top', drawer, text, x, y);
}

function drawSmallText(drawer, text, x, y)
{
  return drawString(o_SmallTextWorkingAreaName, 'left', 'top', drawer, text, x, y);
}

function drawStepLogicalId(drawer, text, x, y, width, height)
{
  var textX = parseInt(x) + parseInt(width) / 2;
  var textY = parseInt(y) + parseInt(height) + 16;
  return drawNormalText(drawer, 'center', 'middle', text, textX, textY);
}

function drawMemoTitle(drawer, text, x, y, width, height)
{
  textX = parseInt(x)+5;
  textY = parseInt(y)+6;
  return drawTitleText(drawer, text, textX, textY).attr({'font-family':o_TitleTextFontFamily,'font-size':o_TitleTextFontSize,'font-weight':o_TitleTextFontWeight,'clip-rect':(''+x+','+y+','+(width-4)+','+height)});
}

function drawMemoDescription(drawer, text, x, y, width, height)
{
  textX = parseInt(x);
  textY = parseInt(y)-3;
  return drawNormalTextWrap(drawer, 'left', 'top', text, textX+5, textY+12, height, width);
}

function drawNumberOfTasks(drawer, numberOfTasks, imageName, x, y)
{
  if(numberOfTasks > 0)
  {
    drawer.layer.push(drawer.paper.image(o_ImagesFolderPath + imageName,
                     x ,
                     y,
                     o_TasksImageWidth,
                     o_TasksImageHeight));
  }
}

function drawArrow(drawer, fill, aX, aY, bX, bY)
{
  var deltaX = bX - aX;
  var deltaY = bY - aY;
  var angle = Math.atan(deltaY / deltaX);
  if(aX > bX)
  {
    angle += Math.PI;
  }

  var angle1 = angle + 30 * Math.PI / 180;
  var angle2 = angle - 30 * Math.PI / 180;

  p1X = bX - o_ArrowLength * Math.cos(angle1);
  p2X = bX - o_ArrowLength * Math.cos(angle2);
  p1Y = bY - o_ArrowLength * Math.sin(angle1);
  p2Y = bY - o_ArrowLength * Math.sin(angle2);

  if(fill)
  {
    /*var xPoints = new Array(bX, p1X, p2X);
    var yPoints = new Array(bY, p1Y, p2Y);
    drawer.fillPolygon(xPoints, yPoints);*/
    var arrow = drawer.paper.path("M"+bX+" "+bY+"L"+p1X+" "+p1Y+"L"+p2X+" "+p2Y+"L"+bX+" "+bY)
    drawer.layer.push(arrow);
    return arrow.attr({fill:"#000"});
  }
  else
  {
    var arrow = drawer.paper.path("M"+bX+" "+bY+"L"+p1X+" "+p1Y+"M"+bX+" "+bY+"L"+p2X+" "+p2Y);
    drawer.layer.push(arrow);
    return arrow;
/*    drawer.drawLine(bX, bY, p1X, p1Y);
    drawer.drawLine(bX, bY, p2X, p2Y);*/
  }
}

function calculateLinkToStepHookPoint(step,
                                      point,
                                      linkedPoint)
{
  var x = point.getX();
  var y = point.getY();
  var linkedX = linkedPoint.getX();
  var linkedY = linkedPoint.getY();
  var stepXL = step.getX();
  var stepXR = step.getX() + step.getWidth();
  var stepYT = step.getY();
  var stepYB = step.getY() + step.getHeight();

  if((y == stepYT || y == stepYB) && stepXL <= x && x <= stepXR)
  {
    // ok, point coordonates matches border
    return point;
  }
  else
  {
    if((x == stepXL || x == stepXR) && stepYT <= y && y <= stepYB)
    {
      // ok, point coordonates matches border
      return point;
    }
    else
    {
      if(linkedX < stepXL)
      {
        x = stepXL;
      }
      else if(linkedX > stepXR)
      {
        x = stepXR;
      }
      if(linkedY < stepYT)
      {
        y = stepYT;
      }
      else if(linkedY > stepYB)
      {
        y = stepYB;
      }
      return new Point(x, y);
    }
  }
}
document.canvasDrawer = new Object();
function CanvasDrawer(raphPaper, canvasName) {
  this.paper = raphPaper;
  this.layer = raphPaper.set();
  this.name = canvasName;
  this.visible = true;
  document.canvasDrawer[canvasName] = this;
  this.setVisible = function(pVisible) {
    if (pVisible) {
      this.layer.forEach(function(el) {
        el.show();
      });
    } else {
      this.layer.forEach(function(el) {
        el.hide();
      });
    }
    this.visible = pVisible;
  }
  this.isVisible = function() {
    return this.visible;
  } 
}

var modelCanvasDrawer;
var textCanvasDrawer;
var tasksCanvasDrawer;
var memoCanvasDrawer;
var assignmentCanvasDrawer;
var deadlineCanvasDrawer;
var actionCanvasDrawer;

function parseParameters(language, dictionary, parametersNode)
{
  var isValid = false;
  var canvasHeight = o_CanvasHeight;
  var canvasWidth = o_CanvasWidth;
  for(var i = 0 ; i < parametersNode.attributes.length ; i++)
  {
    var attribute = parametersNode.attributes[i];
    if(attribute.nodeName == "version")
    {
      var version = parseInt(attribute.nodeValue);
      if(o_MaximumSupportedVersion >= version)
      {
        isValid = true;
      }
    }
    else if(attribute.nodeName == "xMaximum")
    {
      var width = parseInt(attribute.nodeValue);
      canvasWidth = width + 20;
    }
    else if(attribute.nodeName == "yMaximum")
    {
      var height = parseInt(attribute.nodeValue);
      canvasHeight = height + 20;                
    }
  }
  if (isValid) {
    $("#BackgroundCanvas").css({"width":Math.min($(window).width(), canvasWidth+9),"height":Math.min($(window).height(), canvasHeight+9)});
    var canvas = Raphael("canvas", canvasWidth, canvasHeight);
    modelCanvasDrawer = new CanvasDrawer(canvas, "ModelCanvas");
    textCanvasDrawer = new CanvasDrawer(canvas, "TextCanvas");
    tasksCanvasDrawer = new CanvasDrawer(canvas, "TasksCanvas");
    memoCanvasDrawer = new CanvasDrawer(canvas, "MemoCanvas");
    assignmentCanvasDrawer = new CanvasDrawer(canvas, "AssignmentCanvas");
    deadlineCanvasDrawer = new CanvasDrawer(canvas, "DeadlineCanvas");
    actionCanvasDrawer = new CanvasDrawer(canvas, "ActionCanvas");

    graphicalContext = new GraphicalContext(language,
                                                dictionary,
                                                spacer,
                                                contentCanvas,
                                                backgroundCanvas);  
  }
  return isValid;
}

function parseWatchedStep(graphicalContext, watchedStepNode)
{
  for(var i = 0 ; i < watchedStepNode.attributes.length ; i++)
  {
    var attribute = watchedStepNode.attributes[i];
    if(attribute.nodeName == "refid")
    {
      var refid = attribute.nodeValue;
    }
  }

  return refid;
}

function parseWatchedSteps(graphicalContext, watchedStepsNode)
{
  var watchedStepIds = new Array();
  for(var i = 0 ; i < watchedStepsNode.childNodes.length ; i++)
  {
    var childNode = watchedStepsNode.childNodes[i];
    if(childNode.nodeName == "watchedStep")
    {
      var refid = parseWatchedStep(graphicalContext, childNode);
      watchedStepIds.push(refid);
    }
  }

  return watchedStepIds;
}

function parseSubWorkcase(subWorkcaseNode)
{
  for(var i = 0 ; i < subWorkcaseNode.attributes.length ; i++)
  {
    var attribute = subWorkcaseNode.attributes[i];
    if(attribute.nodeName == "internalId")
    {
      var workcaseId = parseInt(attribute.nodeValue);
    }
  }
  return workcaseId;
}

function parseSubWorkcases(subWorkcasesNode)
{
  var subWorkcaseIds = new Array();
  for(var i = 0 ; i < subWorkcasesNode.childNodes.length ; i++)
  {
    var childNode = subWorkcasesNode.childNodes[i];
    if(childNode.nodeName == "subWorkcase")
    {
      var subWorkcaseId = parseSubWorkcase(childNode);
      subWorkcaseIds.push(subWorkcaseId);
    }
  }
  return subWorkcaseIds;
}

function parseTasksPerState(tasksPerStateNode)
{
  for(var i = 0 ; i < tasksPerStateNode.attributes.length ; i++)
  {
    var attribute = tasksPerStateNode.attributes[i];
    if(attribute.nodeName == "alive")
    {
      var alive = parseInt(attribute.nodeValue);
    }
    else if(attribute.nodeName == "dead")
    {
      var dead = parseInt(attribute.nodeValue);
    }
    else if(attribute.nodeName == "done")
    {
      var done = parseInt(attribute.nodeValue);
    }
    else if(attribute.nodeName == "cancelled")
    {
      var cancelled = parseInt(attribute.nodeValue);
    }
  }
  var tasksPerState =
  {
    'alive' : alive,
    'dead' : dead,
    'done' : done,
    'cancelled' : cancelled
  }
  return tasksPerState;
}

function parseActivity(activityNode)
{
  for(var i = 0 ; i < activityNode.childNodes.length ; i++)
  {
    var childNode = activityNode.childNodes[i];
    if(childNode.nodeName == "logicalId")
    {
      var logicalId = getNodeValue(childNode);
    }
  }
  var activity = new Activity(logicalId);
  return activity;
}

function parseStep(graphicalContext, stepNode)
{
  for(var i = 0 ; i < stepNode.attributes.length ; i++)
  {
    var attribute = stepNode.attributes[i];
    if(attribute.nodeName == "id")
    {
      var id = attribute.nodeValue;
    }
    else if(attribute.nodeName == "internalId")
    {
      var internalId = parseInt(attribute.nodeValue);
    }
    else if(attribute.nodeName == "index")
    {
      var index = parseInt(attribute.nodeValue);
    }
    else if(attribute.nodeName == "x")
    {
      var x = parseInt(attribute.nodeValue);
    }
    else if(attribute.nodeName == "y")
    {
      var y = parseInt(attribute.nodeValue);
    }
    else if(attribute.nodeName == "height")
    {
      var height = parseInt(attribute.nodeValue);
    }
    else if(attribute.nodeName == "width")
    {
      var width = parseInt(attribute.nodeValue);
    }
    else if(attribute.nodeName == "type")
    {
      var type = attribute.nodeValue;
    }
    else if(attribute.nodeName == "algo")
    {
      var algo = attribute.nodeValue;
    }
    else if(attribute.nodeName == "algoReferencedVariable")
    {
      var algoReferencedVariable = attribute.nodeValue;
    }
    else if(attribute.nodeName == "algoReferencedRole")
    {
      var algoReferencedRole = attribute.nodeValue;
    }
    else if(attribute.nodeName == "algoReferencedStep")
    {
      var algoReferencedStep = attribute.nodeValue;
    }
    else if(attribute.nodeName == "deadlineType")
    {
      var deadlineType = attribute.nodeValue;
    }
  }

  for(var i = 0 ; i < stepNode.childNodes.length ; i++)
  {
    var childNode = stepNode.childNodes[i];
    if(childNode.nodeName == "logicalId")
    {
      var logicalId = getNodeValue(childNode);
    }
    else if(childNode.nodeName == "description")
    {
      var description = getNodeValue(childNode);
    }
    else if(childNode.nodeName == "activity")
    {
      var activity = parseActivity(childNode);
    }
    else if(childNode.nodeName == "tasksPerState")
    {
      var tasksPerState = parseTasksPerState(childNode);
    }
    else if(childNode.nodeName == "subWorkcases")
    {
      var subWorkcaseIds = parseSubWorkcases(childNode);
    }
    else if(childNode.nodeName == "watchedSteps")
    {
      var watchedStepIds = parseWatchedSteps(graphicalContext, childNode);
    }
  }

  var dictionary = graphicalContext.getDictionary();
  if(logicalId != null && dictionary['step.' + logicalId])
  {
    logicalId = dictionary['step.' + logicalId];
  }

  if(type == "VOID")
  {
    memoCanvasDrawer.layer.push(memoCanvasDrawer.paper.rect(x,
                                                    y,
                                                    width,
                                                    height).attr({'fill':o_MemoBackgroudColor, 'stroke':o_MemoStrokeColor,'stroke-width':0.5}));
    var descriptionX = x + 2;
    var descriptionY = y + 2;
    if(logicalId != null)
    {
      drawMemoTitle(memoCanvasDrawer, logicalId, x, y + 1, width, height);
      var size = getTextSize(o_TitleTextWorkingAreaName, logicalId);
      memoCanvasDrawer.layer.push(memoCanvasDrawer.paper.path("M"+(x + 1)+" "+
                                                      (y + size.height + 1)+"L"+
                                                      (x + width)+" "+(y + size.height + 1)).attr({'stroke':o_MemoStrokeColor,'stroke-width':0.8}));
      descriptionY = y + size.height + 2;
    }

    if(description != null)
    {
      drawMemoDescription(memoCanvasDrawer,
                          description/*.replace(/\n/g, '<br/>')*/,
                          descriptionX,
                          descriptionY,
                          width,
                          height);
    }
  }
  else
  {
    var useDefaultImage = true;
    var showAlarm = false;
    var showOverdue = false;
    if(activity && activity.getLogicalId())
    {
      if(type.match("^CONNECTOR"))
      {
        var connectorName = activity.getLogicalId();
        if(connectorName.match("_[0-9]{13,13}$"))
        {
          connectorName = connectorName.substring(0, connectorName.length - 14);
        }
        if (skin == "BPMN") {
          customImagePath = o_CustomStepImagesFolderPath + connectorName + "-16.png";
        } else {
          customImagePath = o_CustomStepImagesFolderPath + connectorName + ".gif";
        }
        if(urlExists(customImagePath))
        {
          var imagePath = customImagePath;
          useDefaultImage = false;
        } else {
          var imagePath = o_CustomStepImagesFolderPath + "connector-16.png";
          useDefaultImage = false;
        }
        
        showAlarm = type.match("_ALARM$");
        showOverdue = type.match("_OVERDUE$");
      }
    }

    if(useDefaultImage)
    {
      var imageName = type;
      if(type == "OR_SPLIT" && algo == "XOR")
      {
        imageName = type + "_" + algo;
      }
      var imagePath = o_StepImagesFolderPath + imageName + ".gif";
    }
      
	if (skin == "BPMN") {
	  if(type.match("^(CONNECTOR|AUTOMATED|MANUAL|SUBPROCESS)"))  {
    var xPoints = new Array();
        var yPoints = new Array();

        xPoints.push(x);
	    xPoints.push(x + width);
	    xPoints.push(x + width);
	    xPoints.push(x);
	    xPoints.push(x);
        yPoints.push(y);
	    yPoints.push(y);
	    yPoints.push(y + height);
	    yPoints.push(y + height);
	    yPoints.push(y);
		var colors = getLaneColors(x, y);
		var lightColor = "#ddd";
		var darkColor = "#fff";
		var darkestColor = "#000";
		if (colors!='') {
      lightColor =  colors['colorGradientLight'];
      darkColor = colors['colorGradientDark'];
      darkestColor = colors['color'];
      //darkestColor = Raphael.hsb(darkestColor.h,darkestColor.s,0.3);
    }
	  modelCanvasDrawer.layer.push(modelCanvasDrawer.paper.rect(x, y, width, height,10).attr({'stroke-width':1.5,'stroke':darkestColor,'opacity':1,'fill':'0-'+lightColor+'-'+darkColor,'title':logicalId}));//, colors['colorGradientLight'], colors['colorGradientDark']);

		drawStringInDiv(textCanvasDrawer, logicalId, x, y, width, height);
		}
	  if(type.match("^CONNECTOR") || type.match ("^AUTOMATED")) {
      modelCanvasDrawer.layer.push(modelCanvasDrawer.paper.image(imagePath, x+3, y+2, 16, 16));
   } else if(type.match("^SUBPROCESS")) {
	    modelCanvasDrawer.layer.push(modelCanvasDrawer.paper.image(imagePath, x + (width / 2) - 8, y + height - 16, 16,16));
   } else if(!type.match("^MANUAL")){	
      modelCanvasDrawer.layer.push(modelCanvasDrawer.paper.image(imagePath, x, y,width,height));
      if (logicalId) {
		    drawStepLogicalId(textCanvasDrawer, logicalId, x, y, width, height);
      }												  
   }
   if (type.match ("_ALARM$") || type.match ("_OVERDUE$")) {
		  var alarmOrOverdueImage = null;
      if(type.match ("_ALARM$")) {
        alarmOrOverdueImage = o_ImagesFolderPath + "alarm.gif"
      } else {
        alarmOrOverdueImage = o_ImagesFolderPath + "overdue.gif"
      }
		  modelCanvasDrawer.layer.push(modelCanvasDrawer.paper.image(alarmOrOverdueImage, x+width-18, y+2, 16, 16));
	 }
	}
	else
    {	
    modelCanvasDrawer.layer.push(modelCanvasDrawer.paper.image(imagePath,
                                                        x,
                                                        y,
                                                        width,
                                                        height));
    

    var alarmOrOverdueLayerImage = null;
    if(showAlarm)
    {
      alarmOrOverdueLayerImage = o_ImagesFolderPath + "alarm.gif"
    }
    if(showOverdue)
    {
      alarmOrOverdueLayerImage = o_ImagesFolderPath + "overdue.gif"
    }

    if(alarmOrOverdueLayerImage != null)
    {
      modelCanvasDrawer.layer.push(modelCanvasDrawer.paper.image(alarmOrOverdueLayerImage,
                                                        x,
                                                        y,
                                                        16,
                                                        16));
    }
    }
    if(logicalId != null && skin != 'BPMN')
    {
      drawStepLogicalId(textCanvasDrawer, logicalId, x, y, width, height);
    }

    if(tasksPerState || subWorkcaseIds)
    {
      var canvas = graphicalContext.getContentCanvas();
      // $$$$ check 4$ in file when changing this, some code will be impacted
      var stepElement = appendElement(canvas, "div");
      appendAttribute(stepElement, "id", id);
      appendAttribute(stepElement, "class", "StepMenu");
      var divElement = appendElement(stepElement, "div");
      var tableElement = appendElement(divElement, "table");
      var tbodyElement = appendElement(tableElement, "tbody");
      var trElement = appendElement(tbodyElement, "tr");
      var titleTdElement = appendElement(trElement, "td");
      appendTextElement(titleTdElement, "h1", logicalId);
      var closeTdElement = appendElement(trElement, "td");
      appendAttribute(closeTdElement, "width", "15px");
      var aElement = appendTextElement(closeTdElement, "a", "X");
      appendAttribute(aElement, "href", "javascript:hideCurrentPanel()");
      appendAttribute(aElement, "class", "Close");

      if(tasksPerState)
      {
        drawNumberOfTasks(tasksCanvasDrawer,
                          tasksPerState.done,
                          "done.gif",
                          x - 12,
                          y - 8);
        drawNumberOfTasks(tasksCanvasDrawer,
                          tasksPerState.cancelled,
                          "cancelled.gif",
                          x + o_TasksImageWidth - o_TasksImageWidth / 2,
                          y - 8);
        drawNumberOfTasks(tasksCanvasDrawer,
                          tasksPerState.alive,
                          "alive.gif",
                          x + o_TasksImageWidth + 12,
                          y - 8);

        appendTextElement(stepElement, "h2", dictionary['common.numberOfTasks']);
        var ulElement = appendElement(stepElement, "ul");
        appendTextElement(ulElement, "li", dictionary['common.numberOfTasks.alive'] + " " + tasksPerState.alive);
        appendTextElement(ulElement, "li", dictionary['common.numberOfTasks.done'] + " " + tasksPerState.done);
        appendTextElement(ulElement, "li", dictionary['common.numberOfTasks.cancelled'] + " " + tasksPerState.cancelled);
      }

      if(subWorkcaseIds && subWorkcaseIds.length > 0)
      {
        appendTextElement(stepElement, "h2", dictionary['common.subWorkcases']);
        var ulElement = appendElement(stepElement, "ul");

        for(i = 0 ; i < subWorkcaseIds.length ; i++)
        {
          var subWorkcaseId = subWorkcaseIds[i];

          var liElement = appendElement(ulElement, "li");
          var aElement = appendTextElement(liElement, "a", subWorkcaseId);
          var language = graphicalContext.getLanguage();
          appendAttribute(aElement,
                          "href",
                          o_FollowUpPagePath + "?workcaseInternalId=" + subWorkcaseId + "&language=" + language);
        }
      }

      var attributes = 'class="ClickableStep" onclick="javascript:displayPanel(this, \'' + id + '\')"';
      var stepImage = actionCanvasDrawer.layer.push(actionCanvasDrawer.paper.image(o_ImagesFolderPath + "empty.gif",
                                                         x,
                                                         y,
                                                         width,
                                                         height));
      stepImage.data("id",id);                                                               
      stepImage.click(function(e) {
       traceInfo("click on "+this.data("id"));
       displayPanel(this, this.data("id"));
      });
    }
  }

  if(algo != "NULL" && algo != "XOR")
  {
    var assignmentY = y - o_AssignmentImageHeight - 2;
    var imageName = algo;
    
    assignmentCanvasDrawer.layer.push(assignmentCanvasDrawer.paper.image(o_AssignmentImagesFolderPath + imageName + ".gif",
                                                           x,
                                                           assignmentY,
                                                           o_AssignmentImageWidth,
                                                           o_AssignmentImageHeight));
    if(algoReferencedVariable && algoReferencedVariable != "")
    {
      drawSmallText(assignmentCanvasDrawer,
                    "v: " + algoReferencedVariable,
                    x + o_AssignmentImageWidth + 2,
                    assignmentY);
    }

    if(algoReferencedRole && algoReferencedRole != "")
    {
      drawSmallText(assignmentCanvasDrawer,
                    "r: " + algoReferencedRole,
                    x + o_AssignmentImageWidth + 2,
                    assignmentY);
    }
  }

  if(deadlineType == "ALL_STEPS" || deadlineType == "WORKCASE")
  {
    var deadlineX = x - o_DeadlineImageWidth - 2;
    var deadlineY = y - o_DeadlineImageHeight - 2;
    deadlineCanvasDrawer.layer.push(deadlineCanvasDrawer.paper.image(o_DeadlineImagesFolderPath + deadlineType + ".gif",
                                                         deadlineX,
                                                         deadlineY,
                                                         o_DeadlineImageWidth,
                                                         o_DeadlineImageHeight));
  }

  var step = new Step(id, index, type, x, y, width, height, watchedStepIds);
  return step;
}

function parseSteps(graphicalContext, stepNodes)
{
  var steps = new Array();
  var stepsPerId = new Array();
  var stepsPerIndex = new Array();
  for(var i = 0 ; i < stepNodes.childNodes.length ; i++)
  {
    var childNode = stepNodes.childNodes[i];
    if(childNode.nodeName == "step")
    {
      var step = parseStep(graphicalContext, childNode);
      steps.push(step);
      stepsPerId[''+step.getId()] = step;
      stepsPerIndex[''+step.getIndex()] = step;
    }
  }

  for(var i = 0 ; i < steps.length ; i++)
  {
    var step = steps[i];
    var watchedStepIds = step.getWatchedStepIds();
    if(watchedStepIds)
    {
      for(var j = 0 ; j < watchedStepIds.length ; j++)
      {
        var watchedStepId = watchedStepIds[j];
        var watchedStep = stepsPerId[watchedStepId];
        var stepWidth2 =  step.getWidth() / 2;
        var stepX = step.getX();
        var stepCX = stepX + stepWidth2;
        var stepHeight2 = step.getHeight() / 2;  
        var stepY = step.getY();
        var stepCY = stepY + stepHeight2;
        var watchedStepWidth2 = watchedStep.getWidth() / 2;
        var watchedStepX = watchedStep.getX();
        var watchedStepCX = watchedStepX + watchedStepWidth2;
        var watchedStepHeight2 = watchedStep.getHeight() / 2;
        var watchedStepY = watchedStep.getY();
        var watchedStepCY = watchedStepY + watchedStepHeight2;
        var deltaX = watchedStepCX - stepCX + 0.1;
        var deltaY = watchedStepCY - stepCY + 0.1;
 traceInfo("deltaX : "+deltaX);
 traceInfo("deltaY : "+deltaY);
        var signDeltaX = (deltaX<0)?-1:1;
        var signDeltaY = (deltaY<0)?-1:1;        
        var ratioStep = deltaX/deltaY/(stepWidth2/stepHeight2);
        var ratioWatchedStep = deltaX/deltaY/(watchedStepWidth2/watchedStepHeight2);
 traceInfo("ratioStep : "+ratioStep);
 traceInfo("ratioWatchedStep : "+ratioWatchedStep);
 
        if (-1<ratioStep && ratioStep <1){
            traceInfo("ratio min");
            stepFX = Math.round(stepCX + signDeltaY * stepWidth2 * ratioStep);                  
            stepFY = Math.round(stepCY + signDeltaY * stepHeight2);
        } else {
            traceInfo("ratio max");
            stepFX = Math.round(stepCX + signDeltaX * stepWidth2);
            stepFY = Math.round(stepCY + signDeltaX * stepHeight2 / ratioStep);
        }        
        if (-1<ratioWatchedStep && ratioWatchedStep <1) {
            traceInfo("watched ratio min");
            watchedStepFX = Math.round(watchedStepCX - signDeltaY * watchedStepWidth2 * ratioWatchedStep);                  
            watchedStepFY = Math.round(watchedStepCY - signDeltaY * watchedStepHeight2);
        } else {
            traceInfo("watched ratio max");
            traceInfo("signDeltaX" + (signDeltaX * watchedStepWidth2));
            watchedStepFX = Math.round(watchedStepCX - signDeltaX * watchedStepWidth2);
            watchedStepFY = Math.round(watchedStepCY - signDeltaX * watchedStepHeight2 / ratioWatchedStep);
        }  
        deadlineCanvasDrawer.layer.push(deadlineCanvasDrawer.paper.path("M"+stepFX+" "+stepFY+"L"+
                                                            watchedStepFX+" "+
                                                            watchedStepFY).attr({'stroke':o_DeadlineLinkColor,'stroke-dasharray':'--'}));
        drawArrow(deadlineCanvasDrawer,
                  true,
                  stepFX,
                  stepFY,
                  watchedStepFX,
                  watchedStepFY).attr({'stroke':'blue','fill':'blue'});
      }
    }
  }

  var steps = new Steps(stepsPerId, stepsPerIndex);
  return steps;
}

function parsePoint(pointNode)
{
  for(var i = 0 ; i < pointNode.attributes.length ; i++)
  {
    var attribute = pointNode.attributes[i];
    if(attribute.nodeName == "x")
    {
      var x = parseInt(attribute.nodeValue);
    }
    else if(attribute.nodeName == "y")
    {
      var y = parseInt(attribute.nodeValue);
    }
  }
  var point = new Point(x, y);
  return point;
}

function parsePoints(pointNodes)
{
  var points = new Array();
  for(var i = 0 ; i < pointNodes.childNodes.length ; i++)
  {
    var childNode = pointNodes.childNodes[i];
    if(childNode.nodeName == "point")
    {
      var point = parsePoint(childNode);
      points.push(point);
    }
  }
  return points;
}

function drawPolyline(drawer, xPoints, yPoints) {
    if(xPoints.length>0) {
      var pathStr = "M"+xPoints[0]+" "+yPoints[0];
      for(var pointIndex = 1;pointIndex<xPoints.length;pointIndex++) {
         pathStr += "L"+xPoints[pointIndex]+" "+yPoints[pointIndex];
      }
      var polyline = drawer.paper.path(pathStr).attr({'stroke-width':0.5});
      drawer.layer.push(polyline);
      return polyline;
    }
}

function parseLink(graphicalContext, steps, linkNode)
{
  for(var i = 0 ; i < linkNode.attributes.length ; i++)
  {
    var attribute = linkNode.attributes[i];
    if(attribute.nodeName == "type")
    {
      var type = attribute.nodeValue;
    }
    else if(attribute.nodeName == "startStepIndex")
    {
      var startStepIndex = parseInt(attribute.nodeValue);
    }
    else if(attribute.nodeName == "endStepIndex")
    {
      var endStepIndex = parseInt(attribute.nodeValue);
    }
    else if(attribute.nodeName == "isSynchronizationLink")
    {
      var isSynchronizationLink = attribute.nodeValue;
      isSynchronizationLink = (isSynchronizationLink == "true");
    }
  }

  for(var i = 0 ; i < linkNode.childNodes.length ; i++)
  {
    var childNode = linkNode.childNodes[i];
    if(childNode.nodeName == "text")
    {
      var text = getNodeValue(childNode);
    }
    else if(childNode.nodeName == "points")
    {
      var points = parsePoints(childNode);
    }
  }

  if(points.length > 1)
  {
    var stepsPerIndex = steps.getStepsPerIndex();
    var startStep = stepsPerIndex[''+startStepIndex];
    var endStep = stepsPerIndex[''+endStepIndex];

    var xPoints = new Array();
    var yPoints = new Array();
    var textSegmentFound = false;
    for(var i = 0 ; i < points.length ; i++)
    {
      var point = points[i];

      if(i == 0)
      {
        point = calculateLinkToStepHookPoint(startStep,
                                             point,
                                             points[1]);
      }
      else if(i == points.length - 1)
      {
        point = calculateLinkToStepHookPoint(endStep,
                                             point,
                                             points[points.length - 2]);
      }

      var x = point.getX();
      var y = point.getY();
      xPoints.push(x);
      yPoints.push(y);
      if(!textSegmentFound && i >= points.length / 2)
      {
        var aX = xPoints[i-1];
        var bX = xPoints[i];
        var aY = yPoints[i-1];
        var bY = yPoints[i];
        var textX = (aX + bX) / 2;
        var textY = (aY + bY) / 2;
        textSegmentFound = true;
      }
    }

    var startStepType = startStep.getType();
    var endStepType = endStep.getType();
    var drawer;
    var appliedStyle = new Object();
    var mustDrawArrow = true;
    if(startStepType == "VOID" || endStepType == "VOID")
    {
      mustDrawArrow = false;
      drawer = memoCanvasDrawer;
      appliedStyle['stroke'] = o_MemoLinkColor;
      appliedStyle['stroke'] = o_MemoLinkColor;
    }
    else
    {
      drawer = modelCanvasDrawer;
      if(isSynchronizationLink)
      {
        appliedStyle['stroke'] = o_SynchronizationLinkColor;
        appliedStyle['stroke-dasharray'] = o_SynchronizationLinkStroke;
      }
      else
      {
        if(type == "NORMAL")
        {
          appliedStyle['stroke'] = o_NormalLinkColor;
        }
        else if(type == "CONDITIONAL")
        {
          appliedStyle['stroke'] = o_ConditionalLinkColor;
        }
      }
    }

    //drawer.drawPolyline(xPoints, yPoints);
    drawPolyline(drawer, xPoints, yPoints).attr(appliedStyle);
    if(mustDrawArrow)
    {
      appliedStyle['fill'] = appliedStyle['stroke'];
      drawArrow(drawer,
                !isSynchronizationLink,
                xPoints[i-2],
                yPoints[i-2],
                xPoints[i-1],
                yPoints[i-1]).attr(appliedStyle);
    }

    if(text != null)
    {
      var size = getTextSize(o_NormalTextWorkingAreaName, text);
      drawNormalText(textCanvasDrawer,
                     'center',
                     'top',
                     text,
                     textX,
                     textY - size.height);
    }
  }
}

function parseLinks(graphicalContext, steps, linkNodes)
{
  for(var i = 0 ; i < linkNodes.childNodes.length ; i++)
  {
    var childNode = linkNodes.childNodes[i];
    if(childNode.nodeName == "link")
    {
      parseLink(graphicalContext, steps, childNode);
    }
  }
}

function parseDouble (value)
{
  return value;
}

function parseLane(graphicalContext, laneNode)
{
  for (var i = 0 ; i < laneNode.childNodes.length ; i++)
  {
    var childNode = laneNode.childNodes[i];
    if(childNode.nodeName == "posX")
    {
      var posX = parseInt (getNodeValue(childNode));
    }
    else if(childNode.nodeName == "posY")
    {
      var posY = parseInt (getNodeValue(childNode));
    }
    else if(childNode.nodeName == "width")
    {
      var width = parseInt (getNodeValue(childNode));
    }
    else if(childNode.nodeName == "title_width")
    {
      var titleWidth = parseInt (getNodeValue(childNode));
    }
    else if(childNode.nodeName == "height")
    {
      var height = parseInt (getNodeValue(childNode));
    }
	else if(childNode.nodeName == "str")
    {
      var str = getNodeValue(childNode);
    }
	else if(childNode.nodeName == "str")
    {
      var str = getNodeValue(childNode);
    }
	else if(childNode.nodeName == "propagate_color")
    {
      var propagateColor = (getNodeValue(childNode) == 'true');
    }
	else if(childNode.nodeName == "color")
    {
      var color = getColorFromJavaRgb (parseInt (getNodeValue(childNode)));
	  var colorLight = getLightColorFromJavaRgb (parseInt (getNodeValue(childNode)));
	  var colorGradientLight = getLightColorGradientFromJavaRgb (parseInt (getNodeValue(childNode)));
	  var colorGradientDark = getDarkColorGradientFromJavaRgb (parseInt (getNodeValue(childNode)));
    }
  }

  if (propagateColor)
  {
    laneNames.push(str);
    colorsPerLaneStr[str] = new Object ();
	colorsPerLaneStr[str]['color'] = color;
	colorsPerLaneStr[str]['colorLight'] = colorLight;
	colorsPerLaneStr[str]['colorGradientLight'] = colorGradientLight;
	colorsPerLaneStr[str]['colorGradientDark'] = colorGradientDark;
	colorsPerLaneStr[str]['posX'] = posX;
	colorsPerLaneStr[str]['posY'] = posY;
	colorsPerLaneStr[str]['height'] = height;
	colorsPerLaneStr[str]['width'] = width;
  }

  var xPoints = new Array();
  var yPoints = new Array();

  xPoints.push(posX);
  xPoints.push(posX + width);
  xPoints.push(posX + width);
  xPoints.push(posX);
  xPoints.push(posX);
  yPoints.push(posY);
  yPoints.push(posY);
  yPoints.push(posY + height);
  yPoints.push(posY + height);
  yPoints.push(posY);
  
  var modelDrawer = modelCanvasDrawer;
  
  var xPoints2 = new Array();
  var yPoints2 = new Array();
  
  xPoints2.push(posX + titleWidth);
  xPoints2.push(posX + titleWidth);
  yPoints2.push(posY);
  yPoints2.push(posY + height);

  modelDrawer.layer.push(modelDrawer.paper.rect(posX, posY, width, height).attr({'stroke':color,'fill':'white'}));
  modelDrawer.layer.push(modelDrawer.paper.rect(posX, posY, titleWidth, height).attr({'stroke':color,'fill':colorLight}));
  drawStringRotate (textCanvasDrawer, str, posX , posY , '-90deg', height, titleWidth);
}

function getColorFromJavaRgb (val)
{
  var red = (val >> 16) & 0xFF;
  var green = (val >> 8) & 0xFF;
  var blue = (val >> 0) & 0xFF;
  return getColorString (red, green, blue);
}

function getModifiedColorFromJavaRgb (val, sfactor, bfactor)
{
  var r = (val >> 16) & 0xFF;
  var g = (val >> 8) & 0xFF;
  var b = (val >> 0) & 0xFF;

  var hsb = rgbToHsb(r, g, b);

  if (hsb[2] < bfactor)
  {  
    hsb[2] = bfactor;
  }
  hsb[1] /= sfactor;

  var rgb = hsbToRgb (hsb[0], hsb[1], hsb[2]);

  return getColorString (Math.floor(rgb[0]), Math.floor(rgb[1]), Math.floor(rgb[2]));
}

function getColorString(r,g,b) {

	var hexVal = function(n) {

		var data = "0123456789ABCDEF";

		if (n==null) return "00";

		n=parseInt(n); 

		if (n==0 || isNaN(n)) return "00";

		n=Math.round(Math.min(Math.max(0,n),255));

		return data.charAt((n-n%16)/16) + data.charAt(n%16);

	}

	return "#" + hexVal(r)+hexVal(g)+hexVal(b);

}


function getLightColorFromJavaRgb (val)
{
  return getModifiedColorFromJavaRgb(val, 6, 0.9);
}

function getLightColorGradientFromJavaRgb (val)
{
  return getModifiedColorFromJavaRgb(val, 40, 0.98);
}

function getDarkColorGradientFromJavaRgb (val)
{
  return getModifiedColorFromJavaRgb(val, 5, 0.85);
}

function rgbToHsb(r, g, b) 
{
  var h, s, b2;
  var max = Math.max(r, g, b), min = Math.min(r, g, b);

  b2 = parseFloat(max) / 255.0;
  if (max != 0)
  {
    s = (max - min) / max;
  }
  else
  {
    s = 0.0;
  }
  if (s == 0.0)
  {
    h = 0.0;
  }
  else 
  {
    var red = (max - r) / (max - min);
    var green = (max - g) / (max - min);
	var blue = (max - b) / (max - min);
	if (r == max)
	{
	  h = blue - green;
	}
	else if (g == max)
	{
	  h = 2.0 + red - blue;
	}
    else
	{
	  h = 4.0 + green - red;
	}
	h = h / 6.0;
	if (h < 0)
	{
      h += 1.0;
	}
  }
  return [h, s, b2];
}

function hsbToRgb(hue, saturation, brightness)
{
  var r = 0, g = 0, b = 0;
  if (saturation == 0)
  {
    r = g = b = (brightness * 255.0) + 0.5;
  } 
  else 
  {
    var h = (hue - Math.floor(hue)) * 6.0;
	var f = h - Math.floor(h);
	var p = brightness * (1.0 - saturation);
	var q = brightness * (1.0 - (saturation * f));
	var t = brightness * (1.0 - (saturation * (1.0 - f)));
	switch (Math.floor (h)) 
	{
	  case 0:
		r = brightness * 255.0 + 0.5;
		g = t * 255.0 + 0.5;
		b = p * 255.0 + 0.5;
		break;
	  case 1:
		r = q * 255.0 + 0.5;
		g = brightness * 255.0 + 0.5;
		b = p * 255.0 + 0.5;
		break;
	  case 2:
		r = p * 255.0 + 0.5;
		g = brightness * 255.0 + 0.5;
		b = t * 255.0 + 0.5;
		break;
	  case 3:
		r = p * 255.0 + 0.5;
		g = q * 255.0 + 0.5;
		b = brightness * 255.0 + 0.5;
		break;
	  case 4:
		r = t * 255.0 + 0.5;
		g = p * 255.0 + 0.5;
		b = brightness * 255.0 + 0.5;
		break;
	  case 5:
		r = brightness * 255.0 + 0.5;
		g = p * 255.0 + 0.5;
		b = q * 255.0 + 0.5;
		break;
	}
  }
  return [r, g, b];
}

function parseLanes(graphicalContext, laneNodes)
{
  for(var i = 0 ; i < laneNodes.childNodes.length ; i++)
  {
    var childNode = laneNodes.childNodes[i];
    if(childNode.nodeName == "lane")
    {
      parseLane(graphicalContext, childNode);
    }
  }
}

var graphicalContext;
var spacer;
var contentCanvas;
var backgroundCanvas;
var modelCanvas;
var textCanvas;
var tasksCanvas;
var memoCanvas;
var assignmentCanvas;
var deadlineCanvas;
var actionCanvas; 
function parseFollowUp(language,
                       dictionary,
                       followUpNode)
{
  spacer = document.getElementById(o_SpacerName);
  contentCanvas = document.getElementById(o_ContentCanvasName);
  backgroundCanvas = document.getElementById(o_BackgroundCanvasName);
  modelCanvas = document.getElementById(o_ModelCanvasName);
  textCanvas = document.getElementById(o_TextCanvasName);
  tasksCanvas = document.getElementById(o_TasksCanvasName);
  memoCanvas = document.getElementById(o_MemoCanvasName);
  assignmentCanvas = document.getElementById(o_AssignmentCanvasName);
  deadlineCanvas = document.getElementById(o_DeadlineCanvasName);
  actionCanvas = document.getElementById(o_ActionCanvasName);

  var isValid = false;
  for(var i = 0 ; i < followUpNode.childNodes.length ; i++)
  {
    var childNode = followUpNode.childNodes[i];
    if(childNode.nodeName == "parameters")
    {
      
      isValid = parseParameters(language, dictionary, childNode);
      break;
    }
  }
  
  if (isValid) {
    // init skin
    for(var i = 0 ; i < followUpNode.childNodes.length ; i++)
    {
      var skinToUse = "";
      var childNode = followUpNode.childNodes[i];
      if(childNode.nodeName == "steps") {
  	    for(var j = 0 ; j < childNode.childNodes.length ; j++) {
          var stepNode = childNode.childNodes[j];
          if(stepNode.nodeName == "step") {
  		      for(var k = 0 ; k < stepNode.attributes.length ; k++) {
              var attribute = stepNode.attributes[i];
              if(attribute.nodeName == "height") {
                var height = parseInt(attribute.nodeValue);
  	       	    if (height > 32) {
  				        skinToUse = "BPMN";
  				        break;
  			        }
              } else if(attribute.nodeName == "width") {
                var width = parseInt(attribute.nodeValue);
  		          if (width > 32) {
  				        skinToUse = "BPMN";
  				        break;
  			        }
              }
  		      }
          }
        }
  	    if (skinToUse == "BPMN") {
          initSkin (skinToUse);
  	    }
      }
    }

    for(var i = 0 ; i < followUpNode.childNodes.length ; i++) {
      var childNode = followUpNode.childNodes[i];
      if(childNode.nodeName == "lanes") {
        parseLanes(graphicalContext, childNode);
      }
    }
    for(var i = 0 ; i < followUpNode.childNodes.length ; i++)
    {
      var childNode = followUpNode.childNodes[i];
      if(childNode.nodeName == "steps") {
          var steps = parseSteps(graphicalContext, childNode);
      } else if(childNode.nodeName == "links") {
          parseLinks(graphicalContext, steps, childNode);
      }
    }
  }

  if(!isValid) {
    var backgroundCanvas = graphicalContext.getBackgroundCanvas();
    var problem = dictionary['common.versionProblem'];
    if(!problem)
    {
      problem = "Version of XML sent by server is to recent to be treated, cannot display graphical follow up."
    }
    appendTextElement(backgroundCanvas, "span", problem);
  }
}


function getUrlParameter(name)
{
  var name = name.replace(/[\[]/, "\\\[").replace(/[\]]/, "\\\]");
  var pattern = "[\\?&]"+name+"=([^&#]*)";
  var regex = new RegExp(pattern);
  var results = regex.exec(window.location.href);
  if(results == null)
  {
    return "";
  }
  else
  {
    return results[1];
  }
}

function loadXml(file)
{
  if(window.ActiveXObject)
  {
    var xmlDoc = new ActiveXObject("Microsoft.XMLDOM");
    xmlDoc.async = false;
    xmlDoc.load(file);
    var rootNode = xmlDoc.childNodes[1];
  }
  else
  {
    var xmlHttpRequest = new window.XMLHttpRequest();
    xmlHttpRequest.open("GET", file, false);
    xmlHttpRequest.send(null);
    if(xmlHttpRequest.responseXML)
    {
      var rootNode = xmlHttpRequest.responseXML.documentElement;
    }
    else
    {
      var text = xmlHttpRequest.responseText;
      var document = (new DOMParser()).parseFromString(text, "text/xml");
      var rootNode = document.documentElement;
    }
  }
  return rootNode;
}

function getAjaxRequest()
{
  if(window.ActiveXObject)
  {
    try
    {
      return new ActiveXObject("Msxml2.XMLHTTP");
    }
    catch(e)
    {
      try
      {
        return new ActiveXObject("Microsoft.XMLHTTP");
      }
      catch(e)
      {
        return null;
      }
    }
  }
  else if(window.XMLHttpRequest)
  {
    return new XMLHttpRequest();
  }
  return null;
}

function initGFU()
{
  setPropertiesToWorkingArea(o_NormalTextWorkingAreaName,
                             o_NormalTextFontFamily,
                             o_NormalTextFontSize,
                             o_NormalTextFontWeight);
  setPropertiesToWorkingArea(o_TitleTextWorkingAreaName,
                             o_TitleTextFontFamily,
                             o_TitleTextFontSize,
                             o_TitleTextFontWeight);
  setPropertiesToWorkingArea(o_SmallTextWorkingAreaName,
                             o_SmallTextFontFamily,
                             o_SmallTextFontSize,
                             o_SmallTextFontWeight);
}

function urlExists(url)
{
  var exists = false;
  var request = getAjaxRequest();
  if(request)
  {
    request.open("HEAD", url, false); // not async
    request.send(null);
    if(request.readyState == 4)
    {
      if(request.status == 200)
      {
        exists = true;
      }
    }
  }
  return exists;
}

function parseEntry(entryNode)
{
  for(var i = 0 ; i < entryNode.childNodes.length ; i++)
  {
    var childNode = entryNode.childNodes[i];
    if(childNode.nodeName == "key")
    {
      var key = getNodeValue(childNode);
    }
    else if(childNode.nodeName == "value")
    {
      var value = getNodeValue(childNode);
    }
  }
  var entry =
  {
    'key' : key,
    'value' : value
  }
  return entry;
}

var translatedDictionary = null;
function getTranslatedDictionary()
{
	var language = getUrlParameter("language");
	return loadDictionary(language);
}

function getTranslatedString(key)
{
  if(translatedDictionary == null)
  {
	  translatedDictionary = getTranslatedDictionary();
  }
  return translatedDictionary[key]; 
}


function readDictionary(url)
{
  var dictionary = new Array();
  var dictionaryElement = loadXml(url);
  for(var i = 0 ; i < dictionaryElement.childNodes.length ; i++)
  {
    var childNode = dictionaryElement.childNodes[i];
    if(childNode.nodeName == "entry")
    {
      var entry = parseEntry(childNode);
      dictionary[entry.key] = entry.value;
    }
  }
  return dictionary;
}

function loadDictionary(language)
{
  var defaultDictionaryPath = o_DictionaryPathPrefix + o_DictionaryExtension;
  var dictionaryPath = o_DictionaryPathPrefix + "_" + language + o_DictionaryExtension;
  if(language != null && language != "" && urlExists(dictionaryPath))
  {
    var dictionary = readDictionary(dictionaryPath);
  }
  else
  {
    if(urlExists(defaultDictionaryPath))
    {
      var dictionary = readDictionary(defaultDictionaryPath);
    }
    else
    {
      var dictionary = new Array();
    }
  }
  return dictionary;
}

function drawGraphicalFollowUp()
{
  initGFU();
  var workcaseInternalId = getUrlParameter("workcaseInternalId");
  var sessionId = getUrlParameter("sessionId");
  var host = getUrlParameter("host");
  var port = getUrlParameter("port");
  

  var followUpNode = loadXml(o_FollowUpDefinitionFilePath + "?workcaseInternalId=" + workcaseInternalId + "&sessionId="
   + sessionId + "&host=" + host + "&port=" + port);
 
  var language = getUrlParameter("language");
  var dictionary = loadDictionary(language);
  parseFollowUp(language,
                dictionary,
                followUpNode);
  
}
