package GestionInterventions.src;

import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;

public class Interval {
	private Date startDate;
	private Date endDate;
	private static final DateFormat dateFormat = new SimpleDateFormat("MM-yyyy");
	
	public Interval(String dateStr){
		try {
			startDate = dateFormat.parse(dateStr);
			Calendar date = Calendar.getInstance();
			date.setTime(startDate);
			date.add(Calendar.MONTH, 1);
			endDate = date.getTime();
		} catch (ParseException e) {
			throw new IllegalArgumentException(e.getMessage(), e.getCause());
		}
	}

	public Date getStartDate() {
		return startDate;
	}

	public Date getEndDate() {
		return endDate;
	}	
	
}
